﻿struct DATABASE_STRING
{
private:
  string Data[];
  int ID[];

  int GetPos( const int iID ) const
  {
    int Pos = this.GetAmount() - 1;

    while ((Pos >= 0) && (this.ID[Pos] != iID))
      Pos --;

    return(Pos);
  }

public:
  int Add( const int iID, const string Str )
  {
    int Pos = this.GetPos(iID);

    if (Pos < 0)
    {
      Pos = ::ArrayResize(this.Data, ::ArrayResize(this.ID, this.GetAmount() + 1)) - 1;

      this.ID[Pos] = iID;
      this.Data[Pos] = NULL;
    }

    this.Data[Pos] += Str;

    return(::StringLen(this.Data[Pos]));
  }

  bool Delete( const int iID )
  {
    const int Pos = this.GetPos(iID);

    if (Pos >= 0)
    {
      const int Size = this.GetAmount() - 1;

      for (int i = Pos; i < Size; i++)
      {
        this.ID[i] = this.ID[i + 1];

        this.Data[i] = this.Data[i + 1];
      }

      ::ArrayResize(this.Data, ::ArrayResize(this.ID, Size));
    }

    return(Pos >= 0);
  }

  int GetAmount( void ) const
  {
    return(::ArraySize(this.ID));
  }

  string Get( const int iID ) const
  {
    const int Pos = this.GetPos(iID);

    return((Pos < 0) ? NULL : this.Data[Pos]);
  }
};